package consume

import (
	"applet/app/cfg"
	"applet/app/db"
	utils2 "applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git"
	md3 "code.fnuoos.com/EggPlanet/egg_system_rules.git/md"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/rule"
	md2 "code.fnuoos.com/EggPlanet/egg_system_rules.git/rule/egg_energy/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"time"
)

func EggEnergyDealUserVirtualCoinDataConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>EggEnergyDealUserVirtualCoinDataConsume>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	egg_system_rules.Init(cfg.RedisAddr)
	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			err = handleEggEnergyDealUserVirtualCoinDataConsume(res.Body)
			if err != nil {
				fmt.Println("EggEnergyDealUserVirtualCoinDataConsume_ERR:::::", err.Error())
				utils2.FilePutContents("EggEnergyDealUserVirtualCoinDataConsume_ERR", utils2.SerializeStr(map[string]interface{}{
					"body": res.Body,
					"err":  err.Error(),
				}))
			}
			//_ = res.Reject(false)
			err = res.Ack(true)
			fmt.Println("err ::: ", err)
		} else {
			panic(errors.New("error getting message"))
		}
	}
}

func handleEggEnergyDealUserVirtualCoinDataConsume(msgData []byte) error {
	time.Sleep(time.Duration(100) * time.Millisecond) //休眠100毫秒
	// 1.解析mq中queue的数据结构体
	var msg *md2.EggEnergyStructForDealUserVirtualCoinData
	err := json.Unmarshal(msgData, &msg)
	if err != nil {
		return err
	}

	engine := db.Db
	session := engine.NewSession()
	err = rule.DealUserVirtualCoin(session, md3.DealUserVirtualCoinReq{
		Kind:         msg.Kind,
		Title:        msg.Title,
		TransferType: msg.TransferType,
		CoinId:       msg.CoinId,
		Uid:          msg.Uid,
		Amount:       msg.Amount,
	})
	if err != nil {
		return err
	}

	return nil
}
