package consume

import (
	"applet/app/cfg"
	utils2 "applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	db "code.fnuoos.com/EggPlanet/egg_models.git/src"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git"
	md2 "code.fnuoos.com/EggPlanet/egg_system_rules.git/md"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/rule"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
)

func EggEnergySettlementPublicGiveActivityCoinConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>EggEnergySettlementPublicGiveActivityCoinConsume>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	egg_system_rules.Init(cfg.RedisAddr)
	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			err = handleEggEnergySettlementPublicGiveActivityCoinConsume(res.Body)
			if err != nil {
				fmt.Println("EggEnergySettlementPublicGiveActivityCoinConsume_ERR:::::", err.Error())
				utils2.FilePutContents("EggEnergySettlementPublicGiveActivityCoinConsume_ERR", utils2.SerializeStr(map[string]interface{}{
					"body": res.Body,
					"err":  err.Error(),
				}))
			}
			//_ = res.Reject(false)
			err = res.Ack(true)
			fmt.Println("err ::: ", err)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleEggEnergySettlementPublicGiveActivityCoinConsume(msgData []byte) error {
	//1、解析mq中queue的数据结构体
	var msg *md2.DealUserVirtualCoinReq
	err := json.Unmarshal(msgData, &msg)
	if err != nil {
		return err
	}
	engine := db.Db
	session := engine.NewSession()
	defer func() {
		session.Close()
		if err := recover(); err != nil {
			_ = logx.Error(err)
		}
	}()
	session.Begin()

	//3、给相应的用户加上个人的团队活跃积分
	err = rule.DealUserVirtualCoin(session, *msg)
	if err != nil {
		session.Rollback()
		return err
	}
	return session.Begin()
}
