package consume

import (
	"applet/app/cfg"
	utils2 "applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"applet/pkg/pb"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git"
	md2 "code.fnuoos.com/EggPlanet/egg_system_rules.git/rule/egg_energy/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"google.golang.org/protobuf/proto"
	"time"
)

func IMEggEnergyBatchSendMessageDataConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>IMEggEnergyBatchSendMessageDataConsume>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	egg_system_rules.Init(cfg.RedisAddr)
	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			err = handleIMEggEnergyBatchSendMessageDataConsume(res.Body)
			if err != nil {
				fmt.Println("IMEggEnergyBatchSendMessageDataConsume_ERR:::::", err.Error())
				utils2.FilePutContents("IMEggEnergyBatchSendMessageDataConsume_ERR", utils2.SerializeStr(map[string]interface{}{
					"body": res.Body,
					"err":  err.Error(),
				}))
			}
			//_ = res.Reject(false)
			err = res.Ack(true)
			fmt.Println("err ::: ", err)
		} else {
			panic(errors.New("error getting message"))
		}
	}
}

func handleIMEggEnergyBatchSendMessageDataConsume(msgData []byte) error {
	time.Sleep(time.Duration(100) * time.Millisecond) //休眠100毫秒
	// 1.解析mq中queue的数据结构体
	var msg *md2.IMEggEnergyStructForBatchSendMessageData
	err := json.Unmarshal(msgData, &msg)
	if err != nil {
		return err
	}

	//TODO::调用im GRPC 接口
	buf, err := proto.Marshal(&pb.Text{
		Text: msg.Content,
	})

	_, err = utils2.GetLogicExtClient(cfg.ImLogicRpc.URL, cfg.ImLogicRpc.PORT).SendMessage(utils2.GetCtx("", utils2.Int64ToStr(msg.SendId), "", ""), &pb.SendMessageReq{
		ReceiverType:       pb.ReceiverType(msg.ReceiverType),
		ReceiverId:         msg.ReceiveIMId,
		ToUserIds:          nil,
		MessageType:        pb.MessageType(msg.MessageType),
		MessageContent:     buf,
		SendTime:           utils2.UnixMilliTime(time.Now()),
		IsPersist:          true,
		MessageContentBack: "",
	})
	if err != nil {
		return err
	}

	return nil
}
