package consume

import (
	"applet/app/cfg"
	utils2 "applet/app/utils"
	"applet/app/utils/cache"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git"
	md3 "code.fnuoos.com/EggPlanet/egg_system_rules.git/md"
	md2 "code.fnuoos.com/EggPlanet/egg_system_rules.git/rule/egg_energy/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_es.git/es"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"time"
)

func IMEggEnergyDelFriendCircleDataConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>IMEggEnergyDelFriendCircleDataConsume>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	egg_system_rules.Init(cfg.RedisAddr)
	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			err = handleIMEggEnergyDelFriendCircleCommentDataConsume(res.Body)
			if err != nil {
				fmt.Println("IMEggEnergyDelFriendCircleDataConsume_ERR:::::", err.Error())
				utils2.FilePutContents("IMEggEnergyDelFriendCircleDataConsume_ERR", utils2.SerializeStr(map[string]interface{}{
					"body": res.Body,
					"err":  err.Error(),
				}))
			}
			//_ = res.Reject(false)
			err = res.Ack(true)
			fmt.Println("err ::: ", err)
		} else {
			panic(errors.New("error getting message"))
		}
	}
}

func handleIMEggEnergyDelFriendCircleCommentDataConsume(msgData []byte) error {
	time.Sleep(time.Duration(100) * time.Millisecond) //休眠100毫秒
	// 1.解析mq中queue的数据结构体
	var msg *md2.IMEggEnergyStructForDelFriendCircleCommentData
	err := json.Unmarshal(msgData, &msg)
	if err != nil {
		return err
	}

	//1、删除es数据
	_, err = es.DeleteDoc(md3.EggFriendCircleCommentEsAlias, msg.CommentIndexId)
	if err != nil {
		return err
	}

	//2、删除redis数据
	key := fmt.Sprintf(md3.CommentLikeCacheKey, msg.CommentIndexId)
	cache.Del(key)
	return nil
}
