package md

type MqQueue struct {
	ExchangeName   string `json:"exchangeName"`     //交换机名字
	Name           string `json:"name"`             //队列名字
	Type           string `json:"type"`             //队列类型
	IsPersistent   bool   `json:"is_persistent"`    //队列是否持久化
	RoutKey        string `json:"rout_key"`         //路由
	BindKey        string `json:"bind_key"`         //绑定的路由
	ConsumeFunName string `json:"consume_fun_name"` //消费方法
}

var RabbitMqQueueKeyList = []*MqQueue{
	{
		ExchangeName:   "egg.energy",
		Name:           "egg_energy_star_level_dividend_queue",
		Type:           TopicQueueType,
		IsPersistent:   false,
		RoutKey:        "star_level_dividend",
		BindKey:        "",
		ConsumeFunName: "EggEnergyStartLevelDividendConsume",
	},
	{
		ExchangeName:   "egg.energy",
		Name:           "egg_energy_fund_data_queue",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "fund_data",
		BindKey:        "",
		ConsumeFunName: "EggEnergyDealFundDataConsume",
	},
	{
		ExchangeName:   "egg.energy",
		Name:           "egg_energy_platform_revenue_data_queue",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "platform_revenue_data",
		BindKey:        "",
		ConsumeFunName: "EggEnergyDealPlatformRevenueDataConsume",
	},
	{
		ExchangeName:   "egg.energy",
		Name:           "egg_deal_user_virtual_coin_queue",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "deal_user_virtual_coin",
		BindKey:        "",
		ConsumeFunName: "EggEnergyDealUserVirtualCoinDataConsume ",
	},
	{
		ExchangeName:   "im.egg.energy",
		Name:           "im_egg_energy_batch_send_message_queue",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "batch_send_message_data",
		BindKey:        "",
		ConsumeFunName: "IMEggEnergyBatchSendMessageDataConsume",
	},
	{
		ExchangeName:   "im.egg.energy",
		Name:           "im_egg_energy_del_friend_comment_circle_queue",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "del_friend_circle_comment_data",
		BindKey:        "",
		ConsumeFunName: "IMEggEnergyDelFriendCircleDataConsume",
	},
	{
		ExchangeName:   "egg.app",
		Name:           "egg_fin_withdraw_apply_error_queue",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "egg_fin_withdraw_apply",
		BindKey:        "",
		ConsumeFunName: "EggFinWithdrawApplyDataConsume",
	},
	{
		ExchangeName:   "egg.energy",
		Name:           "egg_energy_settlement_public_give_activity_coin",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "settlement_public_give_activity_coin",
		BindKey:        "",
		ConsumeFunName: "EggEnergySettlementPublicGiveActivityCoinConsume",
	},
	{
		ExchangeName:   "egg.energy",
		Name:           "egg_energy_start_exchange_egg_energy",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "start_exchange_egg_energy",
		BindKey:        "",
		ConsumeFunName: "EggEnergyStartExchangeGreenEnergyConsume",
	},
	{
		ExchangeName:   "egg.energy",
		Name:           "egg_energy_auto_exchange_egg_energy",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "start_exchange_egg_energy",
		BindKey:        "",
		ConsumeFunName: "EggEnergyAutoExchangeGreenEnergyConsume",
	},
}

const (
	EggEnergyStartLevelDividendFunName               = "EggEnergyStartLevelDividendConsume"
	EggEnergyDealFundDataFunName                     = "EggEnergyDealFundDataConsume"
	EggEnergyDealPlatformRevenueDataFunName          = "EggEnergyDealPlatformRevenueDataConsume"
	EggEnergyDealUserVirtualCoinDataFunName          = "EggEnergyDealUserVirtualCoinDataConsume"
	IMEggEnergyBatchSendMessageDataFunName           = "IMEggEnergyBatchSendMessageDataConsume"
	IMEggEnergyDelFriendCircleDataFunName            = "IMEggEnergyDelFriendCircleDataConsume"
	EggFinWithdrawApplyDataConsumeFunName            = "EggFinWithdrawApplyDataConsume"
	EggEnergySettlementPublicGiveActivityCoinFunName = "EggEnergySettlementPublicGiveActivityCoinConsume"
	EggEnergyStartExchangeGreenEnergyFunName         = "EggEnergyStartExchangeGreenEnergyConsume"
	EggEnergyAutoExchangeGreenEnergyFunName          = "EggEnergyAutoExchangeGreenEnergyConsume"
)
